<?php
	function bbcodesmilie($string)
	{
		global $smileypath;
		
		// Umlaute ersetzen
		$string = str_replace('', '&Ouml;', $string);
		$string = str_replace('', '&Auml;', $string);
		$string = str_replace('', '&Uuml;', $string);
		$string = str_replace('', '&ouml;', $string);
		$string = str_replace('', '&auml;', $string);
		$string = str_replace('', '&uuml;', $string);
		$string = str_replace('', '&#223;', $string);
		
		// Smilies ersetzen
		$string = str_replace('&quot;)', '")', $string); // Zeichen ersetzen, damit kein Smilie daraus gemacht wird
		$string = str_replace('&quot;D', '"D', $string);
		$string = str_replace('&#129;&#129;&#129;', '<img src="'.$smileypath.'huh.gif" alt="Huh">', $string);
		$string = str_replace(':)', '<img src="'.$smileypath.'smiley.gif" alt="Smiley">', $string);
		$string = str_replace(';)', '<img src="'.$smileypath.'wink.gif" alt="Wink">', $string);
		$string = str_replace(';D', '<img src="'.$smileypath.'grin.gif" alt="Grin">', $string);
		$string = str_replace(':D', '<img src="'.$smileypath.'cheesy.gif" alt="Cheesy">', $string);
		$string = str_replace('):(', '<img src="'.$smileypath.'angry.gif" alt="Angry">', $string);
		$string = str_replace(':(', '<img src="'.$smileypath.'sad.gif" alt="Sad">', $string);
		$string = str_replace(':o', '<img src="'.$smileypath.'shocked.gif" alt="Shocked">', $string);
		$string = str_replace('8)', '<img src="'.$smileypath.'cool.gif" alt="Cool">', $string);
		$string = str_replace('???', '<img src="'.$smileypath.'huh.gif" alt="Huh">', $string);
		$string = str_replace('::]', '<img src="'.$smileypath.'rolleyes.gif" alt="Rolleyes">', $string);
		$string = str_replace(':P', '<img src="'.$smileypath.'tongue.gif" alt="Tongue">', $string);
		$string = str_replace(':-[', '<img src="'.$smileypath.'embarassed.gif" alt="Embarassed">', $string);
		$string = str_replace(':-X', '<img src="'.$smileypath.'lipsrsealed.gif" alt="Lips sealed">', $string);
		$string = str_replace(':-/', '<img src="'.$smileypath.'undecided.gif" alt="Undecided">', $string);
		$string = str_replace(':-(', '<img src="'.$smileypath.'cry.gif" alt="Cry">', $string);
		$string = str_replace('8-[', '<img src="'.$smileypath.'blaze.gif" alt="Blaze">', $string);
		$string = str_replace('")', '&quot;)', $string);
		$string = str_replace('"D', '&quot;D', $string);
	  
		// erste Formatierungen ersetzen
		$string = str_replace('[b]', '<b>', $string);
		$string = str_replace('[/b]', '</b>', $string);
		$string = str_replace('[i]', '<i>', $string);
		$string = str_replace('[/i]', '</i>', $string);
		$string = str_replace('[u]', '<u>', $string);
		$string = str_replace('[/u]', '</u>', $string);
		$string = str_replace('[/size]', '</span>', $string);
		$string = str_replace('[/color]', '</span>', $string);
	  
		// Ersatz fr Formatierungen (Links, Farbe, Groesse, Bilder) 
		$bbcode_array['color'] = '<span style="color: {COLOR}">';
		$bbcode_array['size'] = '<span style="font-size: {SIZE}px">';
		$bbcode_array['img'] = '<img src="{URL}" border="0">';
		$bbcode_array['url'] = '<a href="{URL}" target="_blank">{DESCRIPTION}</a>';
		$bbcode_array['email'] = '<a href="mailto:{EMAIL}">{EMAIL}</a>';
		// Anpassung
		$bbcode_array['color'] = str_replace('{COLOR}', '\\1', $bbcode_array['color']);
		$bbcode_array['size'] = str_replace('{SIZE}', '\\1', $bbcode_array['size']);
		$bbcode_array['img'] = str_replace('{URL}', '\\1', $bbcode_array['img']);
		$bbcode_array['url1'] = str_replace('{URL}', '\\1', $bbcode_array['url']);
		$bbcode_array['url1'] = str_replace('{DESCRIPTION}', '\\1', $bbcode_array['url1']);	
		$bbcode_array['url2'] = str_replace('{URL}', 'http://\\1', $bbcode_array['url']);
		$bbcode_array['url2'] = str_replace('{DESCRIPTION}', '\\1', $bbcode_array['url2']);	
		$bbcode_array['url3'] = str_replace('{URL}', '\\1', $bbcode_array['url']);
		$bbcode_array['url3'] = str_replace('{DESCRIPTION}', '\\2', $bbcode_array['url3']);	
		$bbcode_array['url4'] = str_replace('{URL}', 'http://\\1', $bbcode_array['url']);
		$bbcode_array['url4'] = str_replace('{DESCRIPTION}', '\\3', $bbcode_array['url4']);	
		$bbcode_array['email'] = str_replace('{EMAIL}', '\\1', $bbcode_array['email']);
		// Bedingungen fr Ersetzen
		$patterns[] = "#\[img\]([^?](?:[^\[]+|\[(?!url))*?)\[/img\]#i";
		$replacements[] = $bbcode_array['img'];	
		$patterns[] = "#\[url\]([\w]+?://([\w\#$%&~/.\-;:=,?@\]+]+|\[(?!url=))*?)\[/url\]#is";
		$replacements[] = $bbcode_array['url1'];	
		$patterns[] = "#\[url\]((www|ftp)\.([\w\#$%&~/.\-;:=,?@\]+]+|\[(?!url=))*?)\[/url\]#is";
		$replacements[] = $bbcode_array['url2'];	
		$patterns[] = "#\[url=([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*?)\]([^?\n\r\t].*?)\[/url\]#is";
		$replacements[] = $bbcode_array['url3'];	
		$patterns[] = "#\[url=((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*?)\]([^?\n\r\t].*?)\[/url\]#is";
		$replacements[] = $bbcode_array['url4'];	
		$patterns[] = "#\[email\]([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#si";
		$replacements[] = $bbcode_array['email'];
		// Ersetzen
		$string = preg_replace($patterns, $replacements, $string);
		$string = preg_replace("/\[color=(\#[0-9A-F]{6}|[a-z]+)\]/si", $bbcode_array['color'], $string);
		$string = preg_replace("/\[size=([1-2]?[0-9])\]/si", $bbcode_array['size'], $string);
		// Quotes, Leerzeilen
		$string = str_replace('[quote]', '<div style="padding: 0.3em; margin: 0.3em; background-color: #DDDDDD; border: 1px solid black;"><b><small>Quotation:</small></b><br>', $string);
		$string = str_replace('[/quote]', '</div>', $string);
		return $string;
	}
?>